# Algorithmus-Eigenschaften
- #+BEGIN_NOTE
  **Definition**
  Ein Algorithmus ist eine Verarbeitungsvorschrift (Anweisung zum Handeln) zur Lösung eines Problems (mit Hilfe eines Computers), die folgenden Anforderungen erfüllt:
  #+END_NOTE
	- **Allgemeingültigkeit**, d.h. die Anweisungen besitzen Gültigkeit für die Lösung einer ganzen Klasse von Problemen, nicht nur ein Einzelproblem
	- **Ausführbarkeit**, d.h. die Anweisungen sind für den Befehlsempfänger verständlich formuliert und für diesen ausführbar
	- **Eindeutigkeit**, d.h. an jeder Stelle ist der Ablauf der Anweisungen eindeutig festgelegt
	- **Finitheit**, d.h. die Anweisungsfolge ist durch einen endlichen Text beschrieben
	- **Terminiertheit**, d.h. nach endlich vielen Schritten liefert die Anweisungsfolge eine Lösung des gestellten Problems
	- **Determiniertheit**, d.h. bei jeder Ausführung mit gleichen Startbedingungen und Eingaben erhält man das gleiche Ergebnis
-
- **Beispiele**
	- Verfahren der schriftlichen Addition
	- Testen eines Palindroms
	- Spielregeln eines Gesellschaftsspiels
-
-
-
- # Übung
  
  
  #+BEGIN_PINNED
  **Aufgabe**
  Begründe, ob die vorliegenden Beschreibungen den Bedingungen eines Algorithmus genügen. Finde 3 weitere Abläufe und entscheide, ob die Kriterien erfüllt werden.
  #+END_PINNED
	- Laufen im Kreis
	- Blindes Ziehen von 5 Kugeln aus einer Urne
-
-
- #+BEGIN_PINNED
  **Aufgabe**
  Testen wir mal dein Können in der interaktiven Übung.
  #+END_PINNED
- <iframe src="https://learningapps.org/watch?app=3986858" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
  
  
  <iframe src="https://learningapps.org/watch?app=5060037" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
  
  <iframe src="https://learningapps.org/watch?app=11308502" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
  
  <iframe src="https://learningapps.org/watch?app=1192152" style="border:0px;width:100%;height:500px" webkitallowfullscreen="true" mozallowfullscreen="true"></iframe>
-
- ---
- # Darstellung von Algorithmen
  
  Warum muss ein Algorithmus überhaupt "gezeichnet" werden?
  
  
  #+BEGIN_NOTE
  Da es fast so viele Programmiersprachen wie Muttersprachen gibt, benötigt man einen "Dolmetscher". Dies ist die grafische Darstellung eines Algorithmus. Damit diese einheitlich umgesetzt wird, hat man sich auf Standards geeinigt, dies ist das **Struktogramm** (Nassi-Shneiderman-Diagramm) und das **Flussdiagramm**.
  #+END_NOTE
- **Struktogramm**
  
  ![alternativ](https://upload.wikimedia.org/wikipedia/commons/3/33/NassiShneiderman.png)
  
  *Quelle: wikimedia.org, abgerufen am 12.11.2023*
  
  **Flussdiagramm**
  
  ![alternativtext](https://upload.wikimedia.org/wikipedia/commons/thumb/6/6b/Flowchart_de.svg/1280px-Flowchart_de.svg.png){:height 30, width 200}*
  
  *Quelle: wikimedia.org, abgerufen am 12.11.2023*
-
-
- Im Unterricht werden wir uns auf das Zeichnen von Flussdiagrammen konzentrieren. Wobei zeichnen hier relativ zu sehen ist. Mit Hilfe des Programms *flowAlgorithm* (Desktop/Informatik) werden wir entsprechende Algorithmen entwickeln.