- #+BEGIN_PINNED
  **Aufgabe**
  Schreibe ein Programm, das zählt, wie oft man Würfeln muss, bis die Zahl 6 erscheint.
  
  #+END_PINNED
	- a) Überlege, ob es sich um eine kopfgesteuerte oder fußgesteuerte Schleife handelt.
	- b) Zeichne ein Flussdiagramm zu einem Algorithmus, welcher das oben stehende Programm löst.
	- c) Implementiere deinen Lösungsalgorithmus.
-
- #+BEGIN_PINNED
  **Aufgabe Euklidischer Algorithmus**
  Schreibe ein Programm, was mit Hilfe des Euklidischen Algorithmus den größten gemeinsamen Teiler zweier natürlicher Zahlen ermittelt.
  #+END_PINNED
	- #+BEGIN_QUOTE
	  *Euklidischer Algorithmus*
	  
	  I. Teile die erste Zahl (Dividend) durch die zweite Zahl (Divisor).
	  
	  II. Geht die Division auf, so ist der Divisor der ggT.
	  
	  III. Geht die Division nicht auf, so bleibt ein Rest. Dieser wird zum neuen Divisor, der alte Divisor wird zum neuen Dividenden.
	  
	  IV. Setze das Verfahren fort bis die Division aufgeht (siehe II).
	  #+END_QUOTE
	-
	- *Teste das Verfahren für 544 und 391.*
	  *Start: 544 : 391 = 1 Rest 153*
	-
	- **Hinweise**
	  
	  Folgende Funktionen können dabei genutzt werden:
	  
	  ```java
	  y = a / b; //liefert den ganzzahligen Teil der Division, wenn a und b als Integer deklariert wurden!
	  y = a % b; // liefert den Rest, der sich bei der Division ergibt
	  ```
	-
	- **Beispiele**
		- https://www.pohlig.de/Unterricht/Inf2004/Kap06/Bilder/Euklid1.gif
		- https://assets.serlo.org/legacy/6733_UMBlIU809Q.png
	-
-
-
- ## Schwierigkeitsgrad 1
- #+BEGIN_PINNED
  **Aufgabe Countdown**
  Schreibe ein Programm, dass eine Variable zaehler in 2er-Schritten von 10 bis 0 runterzählt. In jeder Runde soll der Wert auf der Konsole ausgegeben werden.
  #+END_PINNED
- #+BEGIN_PINNED
  **Aufgabe Viele Quadrate**
  Zeichne drei Quadrate nebeneinander. Das erste liegt bei (10,40) und ist 20x20 Pixel groß. Das nächste liegt mit 10 Pixeln Abstand rechts daneben, das dritte wieder 10 Pixel rechts davon.
  Verwende eine While-Schleife, so dass mit einer kleinen Änderung auch 5 oder 2 Quadrate gezeichnet werden können.
  #+END_PINNED
-
- ## Schwierigkeitsgrad 2
- #+BEGIN_PINNED
  **Aufgabe Teiler**
  Schreibe alle Zahlen im Bereich {1, …, 49} auf die Konsole, die durch 7 teilbar sind, und alle, die durch 13 teilbar sind.
  #+END_PINNED
- #+BEGIN_PINNED
  **Aufgabe Heron-Verfahren**
  Das Heron-Verfahren dient zur Ermittlung der Quadratwurzel einer Zahl. Entscheide, welche Zyklenart geeignet ist und zeichne ein Flussdiagramm. Erstelle ein Programm, welches mittels dieses Verfahrens, die Wurzel berechnet.
  #+END_PINNED
	- https://d2wg98g6yh9seo.cloudfront.net/users/242253/242253_LuWiZeGiLiCevuLi5797136157218132.png
-
- ## Schwierigkeitsgrad 3
- #+BEGIN_PINNED
  **Aufgabe Teiler einer Zahl**
  Erstelle ein Programm, das zu einer beliebigen Zahl n alle Teiler ermittelt.
  #+END_PINNED
- #+BEGIN_PINNED
  **Aufgabe Goldbachsche Vermutung**
  Jede beliebige natürliche Zahl größer gleich 4 kann als Summe zweier Primzahlen dargestellt werden. Durch dein Programm sollen diese beiden Primzahlen ermittelt werden.
  #+END_PINNED
- #+BEGIN_PINNED
  **Aufgabe Primfaktorzerlegung**
  Schreibe eine Prozedur, welche alle Primfaktoren einer Zahl n in der Konsole ausgibt.
  #+END_PINNED