## Aufgabe 1
	- #+BEGIN_PINNED
	  **Aufgabe**
	  Betrachte das Beispiel MyTunes. Erläutere, in wie fern dort mit abstrakten Klassen und Methoden gearbeitet werden sollte.
	  #+END_PINNED
- ## Aufgabe 2
  collapsed:: true
	- #+BEGIN_PINNED
	  **Aufgabe**
	  Gegeben ist der nachstehende Quellcode. Welche der Klassen könnte/sollte abstrakt sein? Zeichne dies korrekt in einem Klassendiagramm.
	  #+END_PINNED
		- ```java
		  class Kuenstler {
		  }
		  
		  class BildenderKuenstler extends Kuenstler {
		  }
		  
		  class Maler extends BildenderKuenstler {
		    void male() {
		      println("mal mal mal");
		    }
		  }
		  
		  class Bildhauer extends BildenderKuenstler {
		    void haue() {
		      println("kracks");
		    }
		  }
		  
		  class Musiker extends Kuenstler {
		    void musiziere() {
		      println("tralala");
		    }
		  }
		  ```
- ## Aufgabe 3
  collapsed:: true
	- #+BEGIN_PINNED
	  **Aufgabe (schwer)**
	  Wir sehen uns den neuesten Stand unserer animierten Objekte an:
	  #+END_PINNED
	  
	  ```java
	  ArrayList<Mover> things = new ArrayList<Mover>();
	  
	  void setup() {
	    size(200, 200);
	    things.add(new Ball());
	    things.add(new Ball());
	    things.add(new Quad());
	    things.add(new Ball());
	    things.add(new Quad());
	  }
	  
	  void draw() {
	    background(0);
	    fill(255);
	    noStroke();
	  
	    for (Mover m: things) {
	      m.update();
	      m.render();
	    }
	  }
	  
	  abstract class Mover {
	    PVector location;
	    PVector speed;
	  
	    Mover() {
	      location =
	      new PVector(random(0, width), random(0, height));
	      speed = new PVector(random(-3, 3), random(-3, 3));
	    }
	  
	    abstract void render();
	  
	    void update() {
	      location.add(speed);
	      if (location.x > width || location.x < 0) {
	        speed.x = -speed.x;
	      }
	  
	      if (location.y > height || location.y < 0) {
	        speed.y = -speed.y;
	      }
	    }
	  }
	  
	  class Ball extends Mover {
	    void render() {
	      ellipse(location.x, location.y, 20, 20);
	    }
	  }
	  
	  class Quad extends Mover {
	    void render() {
	      rectMode(CENTER);
	      rect(location.x, location.y, 20, 20);
	    }
	  }
	  ```
	- #+BEGIN_PINNED
	  Nun sollst du den Quad so ändern, dass er rotiert und sich ansonsten nicht im Raum bewegt. Ändere dazu die Klassenhirarchie wie folgt:
	  - Führe eine neue Oberklasse Thing ein, die ab sofort die location enthält.
	  - Führe eine weitere Klasse Rotator ein, die zwei Eigenschaften enthält: angle und angularSpeed. Die Instanzvariable angularSpeed wird im Konstruktor zufällig gewählt (zwischen -0.1 und 0.1) und bestimmt, wie der Drehwinkel angepasst wird.
	  - Zeichne eine sinnvolle Klassenhirarchie auf und bestimme, wo abstrakte Klassen/Methoden sinnvoll sind.
	  - Implementiere die Klasse und ändere insbesondere Quad so ab, dass der Kasten rotiert (Denke an Transformationen, vielleicht hilft auch push/popMatrix).
	  #+END_PINNED
-